/*
Module : DTime+UI.h
Purpose: Defines the interface for UI support for the DTime+ class library
Created: PJN / 21-04-2006

Copyright (c) 2006 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#if _MSC_VER > 1000
#pragma once
#endif //#if _MSC_VER > 1000

#ifndef __DTIMEPLUSUI_H__
#define __DTIMEPLUSUI_H__


//////////////////// Includes /////////////////////////////////////////////////

#include "DTime+.h"


//////////////////// Functions / Classes //////////////////////////////////////

#ifdef _AFX
#pragma warning(suppress: 26429)
void DDX_DateTimeCtrl(CDataExchange* pDX, int nIDC, DTimePlus::CDate<DTimePlus::CGregorianCalendar>& value)
{
#pragma warning(suppress: 26486)
  HWND hWndCtrl{pDX->PrepareCtrl(nIDC)};
  const CWnd* pWnd{CWnd::FromHandle(hWndCtrl)};
#pragma warning(suppress: 26496)
  AFXASSUME(pWnd != nullptr);

  if (pDX->m_bSaveAndValidate)
  {
    SYSTEMTIME sysTime{};
#pragma warning(suppress: 26490)
    const LRESULT result{pWnd->SendMessage(DTM_GETSYSTEMTIME, 0, reinterpret_cast<LPARAM>(&sysTime))};
    if (result == GDT_VALID)
      value.Set(sysTime);
    else
      value.Set();
  }
  else
  {
    SYSTEMTIME sysTime{};
    WPARAM wParam{GDT_NONE};
    if (value.GetAsSystemTime(sysTime))
      wParam = GDT_VALID;

#pragma warning(suppress: 26490)
    pWnd->SendMessage(DTM_SETSYSTEMTIME, wParam, reinterpret_cast<LPARAM>(&sysTime));
  }
}

#pragma warning(suppress: 26429)
void DDX_DateTimeCtrl(CDataExchange* pDX, int nIDC, DTimePlus::CLTimeOfDay<DTimePlus::CLTimeSpan>& value)
{
#pragma warning(suppress: 26486)
  HWND hWndCtrl{pDX->PrepareCtrl(nIDC)};
  const CWnd* pWnd{CWnd::FromHandle(hWndCtrl)};
#pragma warning(suppress: 26496)
  AFXASSUME(pWnd != nullptr);

  if (pDX->m_bSaveAndValidate)
  {
    SYSTEMTIME sysTime{};
#pragma warning(suppress: 26490)
    const LRESULT result{pWnd->SendMessage(DTM_GETSYSTEMTIME, 0, reinterpret_cast<LPARAM>(&sysTime))};
    if (result == GDT_VALID)
      value.Set(sysTime);
    else
      value.Set();
  }
  else
  {
    SYSTEMTIME sysTime{};
    WPARAM wParam{GDT_NONE};
    if (value.GetAsSystemTime(sysTime))
      wParam = GDT_VALID;

#pragma warning(suppress: 26490)
    pWnd->SendMessage(DTM_SETSYSTEMTIME, wParam, reinterpret_cast<LPARAM>(&sysTime));
  }
}
#endif //#ifdef _AFX

#endif //#ifndef __DTIMEPLUSUI_H__
